/* Sistemas Integrados TECNISA

Nome: 0050_PEDTMP_ALTERARESERVA.SQL

Descrio:
Apaga todas as reservas dos tens que j foram expedidos e gera o novo
cdigo que ser chave da tabela

Criao:
06/09/2003 Andr Rodrigo
*/

ALTER TABLE RESERPRODPED
ADD NRRESPRODPED VARCHAR(10)
GO
DECLARE @V_PRXRESERV    VARCHAR(20);
DECLARE @V_CTRESERVA    NUMERIC(15);
DECLARE @V_CDFILIAL     VARCHAR(4);
DECLARE @V_NRPEDIDO     VARCHAR(10);
DECLARE @V_NRITEMPED    VARCHAR(10);
DECLARE @V_NRRESPRODPED VARCHAR(10);
DECLARE @V_CDPRODUTO    VARCHAR(10);
DECLARE @V_CDALMOXARIFE VARCHAR(6);
DECLARE @V_CDLOCALESTOQ VARCHAR(6);
DECLARE @V_NRLOTEESTQ   VARCHAR(20);
DECLARE @V_NRSUBLOTE    VARCHAR(4);
DECLARE @V_CHAVE        VARCHAR(20);
BEGIN
   SET @V_CTRESERVA = 0;
   DECLARE C_RES CURSOR FOR
       SELECT DISTINCT RE.CDFILIAL, RE.NRPEDIDO, RE.NRITEMPED
       FROM RESERPRODPED RE, ITEMPRODUTO IT, ITEMPEDIDO IP
       WHERE RE.CDFILIAL     = IT.CDFILIALPED
         AND RE.NRPEDIDO     = IT.NRPEDIDO
         AND RE.NRITEMPED    = IT.NRITEMPED
         AND RE.CDFILIAL     = IP.CDFILIAL
         AND RE.NRPEDIDO     = IP.NRPEDIDO
         AND RE.NRITEMPED    = IP.NRITEMPED
         AND IP.IDSITITEMPED > '3';
   OPEN C_RES;
   FETCH NEXT FROM C_RES
              INTO @V_CDFILIAL, @V_NRPEDIDO, @V_NRITEMPED;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
       DELETE FROM RESERPRODPED
       WHERE CDFILIAL  = @V_CDFILIAL
         AND NRPEDIDO  = @V_NRPEDIDO
         AND NRITEMPED = @V_NRITEMPED;

       SET @V_CTRESERVA = @V_CTRESERVA + 1;
       IF @V_CTRESERVA = 500 BEGIN
          SET @V_CTRESERVA = 0;
       END;

       FETCH NEXT FROM C_RES
                  INTO @V_CDFILIAL, @V_NRPEDIDO, @V_NRITEMPED;
   END;
   CLOSE C_RES;
   DEALLOCATE C_RES;

   DECLARE C_RESERVA CURSOR FOR
       SELECT
          CDFILIAL,  NRPEDIDO,     NRITEMPED,    NRRESPRODPED,
          CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
          NRSUBLOTE
       FROM RESERPRODPED
       WHERE NRRESPRODPED IS NULL;
   OPEN C_RESERVA;
   FETCH NEXT FROM C_RESERVA
              INTO @V_CDFILIAL,  @V_NRPEDIDO,     @V_NRITEMPED,    @V_NRRESPRODPED,
                   @V_CDPRODUTO, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                   @V_NRSUBLOTE;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_CHAVE = 'CDRESPEDIDO' + @V_CDFILIAL;
      EXEC NOVO_CODIGO @V_CHAVE, @V_PRXRESERV, 1;

      UPDATE RESERPRODPED
      SET NRRESPRODPED = SUBSTRING(@V_PRXRESERV, 11, 10)
      WHERE CDFILIAL     = @V_CDFILIAL
        AND NRPEDIDO     = @V_NRPEDIDO
        AND NRITEMPED    = @V_NRPEDIDO
        AND CDPRODUTO    = @V_CDPRODUTO
        AND CDALMOXARIFE = @V_CDALMOXARIFE
        AND CDLOCALESTOQ = @V_CDLOCALESTOQ
        AND NRLOTEESTQ   = @V_NRLOTEESTQ
        AND NRSUBLOTE    = @V_NRSUBLOTE;

      FETCH NEXT FROM C_RESERVA
                 INTO @V_CDFILIAL,  @V_NRPEDIDO,     @V_NRITEMPED,    @V_NRRESPRODPED,
                      @V_CDPRODUTO, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                      @V_NRSUBLOTE;
   END;
   CLOSE C_RESERVA;
   DEALLOCATE C_RESERVA;
END
GO

